#!/bin/bash
SUBDIR=DASs
SHM="/dev/shm/golem"
ThisDev=RemoteTrainingOsc-I
COMMAND="netcat -w 1 $ThisDev 5555"
scope_address="nc -w 1 $ThisDev 5555"

source $SHM/Commons.sh
source $SHM/Tools.sh

#cd /golem/shm_golem/ActualShot/DASs/RemoteTrainingOsc-I;cp /home/svoboda/Dirigent/DASs/RigolMSO5204-b/RemoteTrainingOsc-I.sh .;source RemoteTrainingOsc-I.sh;PostDischargeFinals;ls -all


function OpenSession()
{
    SCALE=10
    OFFSET=0
    echo "CHANnel1:DISPlay ON;CHANnel1:PROBe 1;CHANnel1:SCALe $SCALE;CHANnel1:OFFSet $OFFSET"|$COMMAND #HV PowSup
    echo "CHANnel2:DISPlay ON;CHANnel2:PROBe 1;CHANnel2:SCALe $SCALE;CHANnel2:OFFSet $OFFSET"|$COMMAND           #Vakuum
    echo "CHANnel3:DISPlay ON;CHANnel3:PROBe 1;CHANnel3:SCALe $SCALE;CHANnel3:OFFSet $OFFSET"|$COMMAND #Bt
    echo "CHANnel4:DISPlay ON;CHANnel4:PROBe 1;CHANnel4:SCALe $SCALE;CHANnel4:OFFSet $OFFSET"|$COMMAND #Et
    echo "TIMebase:DELay:ENABle OFF;TIMebase:MAIN:SCALe 0.001;TIMebase:MAIN:OFFSet 0"|$COMMAND
    echo ":STOP;:CLEAR"|$COMMAND
    echo ":SYSTem:KEY:PRESs MOFF"|$COMMAND
    echo OK
}


function CloseSession()
{
    echo OK
}

function Arming()
{
	echo ":SINGLe"|$scope_address
    echo OK
}



function PostDischargeFinals()
{
    GetOscScreenShot 
    convert -resize $icon_size ScreenShot.png icon.png
    getdata
    web
    
    echo OK
}

function GetOscScreenShot()
{
	echo ":SYSTem:KEY:PRESs MOFF"|$COMMAND
	mRelax
    echo ":DISPLAY:DATA?  ON,OFF,PNG"|$COMMAND|tail -c +12 > $SHM0/$SUBDIR/$ThisDev/ScreenShot.png
    #echo ":DISPLAY:DATA?  ON,OFF,PNG"|$COMMAND
}

function getdata()
{
    for CHANNEL in `seq 1 4`; do 
	echo "$ThisDev oscilloscope  Downloading data for channel $CHANNEL"
	echo ":WAV:SOURCE CHAN$CHANNEL;:WAV:FORM ASCii;:WAV:MODE NORM" |$scope_address;sleep 0.5s;echo ":WAV:DATA?" |$scope_address|cut -c 12-|sed 's/,/\n/g'|tee data$CHANNEL|gnuplot -e 'set terminal jpeg;plot "<cat" w l' > plot$CHANNEL.jpg;
    done
    paste data* > data_all
}

function web()
{
    output='das'
    echo "<html><body><h1>"$ThisDev" oscilloscope</h1><h2>Screenshot</h2><img src="ScreenShot.png" width="50%"><h2>Data</h2><ul>">$output.html
    for channel in `seq 1 4`;do
	echo '<li><img src="plot'$channel'.jpg"/><br/>' >> $output.html;
        echo '<a href="data'$channel'">Channel '$channel'</a></li>' >> $output.html;
    done
#     echo '<li><a href="data_all">Time axis and all channels (as columns)</a></li>' >> $output.html
    echo '<li><a href="data_all">All channels together (as columns)</a></li>' >> $output.html
    echo '</ul><hr/>Generated by <a href=""></a>.</body></html>' >> $output.html
}    
